/*
foreach-loop as  in C-shell

foreach s (list)
  ... $s ...
end
foreach s (`ls`)
  ... $s ...
end


s, cond, delimit can be string_t or char *
foreach (s;str; cond; delimit)
  ... $s ...
foreach (s;`ls`) is the same as  foreach(s;`ls`; NULL; " ;")
  ... $s ...

*/


char *s1, *str="ab cd cds", *cond=NULL, *delimit=" ";
string_t s2;
foreach(s1;str;cond; delimit) 
  printf("s1= %s\n", s1); 

foreach(s2;"AB;CD") 
  printf("s2= %s\n", s2); 
